#include <sta/system_event.hpp>

#include <cmsis_os2.h>


extern osEventFlagsId_t systemEventHandle;


namespace sta
{
	void signalSystemEvents(uint32_t flags)
	{
		osEventFlagsSet(systemEventHandle, flags);
	}
	
	
	void waitForSystemEvents(uint32_t flags, uint32_t options, uint32_t timeout)
	{
		osEventFlagsWait(systemEventHandle, flags, options | osFlagsNoClear, timeout);
	}
	
	
	void signalStartupCompleted()
	{
		signalSystemEvents(STA_SYSTEM_EVENT_STARTUP);
	}

	void waitForStartup()
	{
		waitForSystemEvents(STA_SYSTEM_EVENT_STARTUP, osFlagsWaitAll, osWaitForever);
	}
} // namespace sta
